设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1966|回复: 10

[工具] Z坐标转0

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2016-6-16 15:48:23 | 显示全部楼层 |阅读模式
  • 插件名称 : Z值转0
  • 作  者 : Newer
  • 运行环境 :XDRX API 晓东工具箱 
  • 发布时间 :2016-06-16
  • 命令名称 :XDTB_Z0
  • 插件介绍 :LINE,*POLYLINE,HATCH,DIMENSION,POLYGON实体Z坐标转0
  • 备  注 : (点击图片可以放大)
(点击图片可以放大)

晓东温馨提示 1、运行环境为 晓东工具箱XDRX API 的插件,请下载最新版本的 晓东工具箱XDRX API开发环境 一键安装
2、在ACAD中如何加载插件,请看 论坛插件使用方法
3、如果您有要求需要定制插件,请到 编程申请 论坛发帖求助

插件详细内容

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
本帖最后由 newer 于 2016-6-16 15:49 编辑

演示图片无意义
[sell=2]

  1. (defun c:XDTB_Z0 ( / #endpoint #startpoint e ss typ)
  2.   (xdrx_begin)
  3.   (xdrx_prompt "\n选取Z变0的实体<退出>:")
  4.   (if (setq ss (ssget '((0 . "*polyline,line,dimension,hatch,polygon"))))
  5.     (progn
  6.       (xdrx_setsstodb ss 0)
  7.       (while (setq e (xdrx_getentdata 0))
  8.         (setq typ (car (xdrx_object_classname e)))
  9.         (if (= typ "LINE")
  10.           (progn
  11.             (xdrx_getpropertyvalue e "startpoint" "endpoint")
  12.             (xdrx_setpropertyvalue e "startpoint" (list (car #startpoint)
  13.                                                         (cadr #startpoint)
  14.                                                         0.0
  15.                                                   ) "endpoint"
  16.                                    (list (car #endpoint) (cadr #endpoint)
  17.                                          0.0
  18.                                    )
  19.             )
  20.           )
  21.           (xdrx_setpropertyvalue e "elevation" 0.0)
  22.         )
  23.       )
  24.       (xdrx_prompt "\n处理了" (sslength ss) "个实体的Z坐标到0...")
  25.     )
  26.   )
  27.   (princ)
  28. )

[/sell]
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 1266个

财富等级: 财源广进

发表于 2016-6-16 16:03:26 来自手机 | 显示全部楼层
确切说是投影到某一平面,一般指WCS,麻烦的是UCS下绘制的,而且实体再有XDATA 、扩展词典或者隶属于组等情况,权衡一下再用

点评

本程序并没使用投影,直接修改实体的数据,不影响扩展实体等数据。  详情 回复 发表于 2016-6-17 00:04
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 8318个

财富等级: 富甲天下

发表于 2016-6-16 17:25:21 | 显示全部楼层
跟网上一搜一大把的比起来有什么增强的地方?
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

发表于 2016-6-16 21:03:10 来自手机 | 显示全部楼层
与我的相同,我也取名z0
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 2772个

财富等级: 家财万贯

发表于 2016-6-16 23:15:32 | 显示全部楼层
如果能强制直接在z轴绘图就更完美。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 40个

财富等级: 招财进宝

 楼主| 发表于 2016-6-17 00:04:04 | 显示全部楼层
st788796 发表于 2016-6-16 16:03
确切说是投影到某一平面,一般指WCS,麻烦的是UCS下绘制的,而且实体再有XDATA 、扩展词典或者隶属于组等情 ...

本程序并没使用投影,直接修改实体的数据,不影响扩展实体等数据。

点评

这就够了,可以应付99.9999的情况。  发表于 2016-6-17 12:48
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 8223个

财富等级: 富甲天下

发表于 2016-11-10 15:21:14 | 显示全部楼层
啥也不说了,感谢楼主分享哇!
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 1个

财富等级: 恭喜发财

发表于 2017-3-19 07:05:05 | 显示全部楼层
不错 很实用的功能 感谢分享
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 107个

财富等级: 日进斗金

发表于 2017-3-19 11:38:27 | 显示全部楼层
;;
;;==================================================================
;;程序名: AC_05
;;功能: 选取对象清除Z坐标值
;;==================================================================
;;
(defun C:AC_05 ( / save_worlducs ss1 j1 en1)
(setvar "cmdecho" 0)
(setq save_error *error*)
(setq *error* cyl_error1)
(if (setq ss1 (ssget))
(progn
(command ".undo" "be")
(princ "\n正在处理图形数据,请稍候...")
(terpri)
(setq save_worlducs (getvar "worlducs"))
(command ".ucs" "w")
(setq j1 0)
(repeat (sslength ss1)
(setq en1 (ssname ss1 j1))
(cyl_zerop_3 en1 0)
(setq j1 (+ j1 1))
);end repeat
(princ "\nOK,已将所选图元Z坐标值全部归零。")
(if (= save_worlducs 0) (command ".ucs" "p"))
(command ".undo" "e")
);end progn
);end if
(setq *error* save_error)
(princ)
);end defun C:AC_05
;;====================================================================
;;

好久没用CAD了,终于在这台老电脑上搜索到这段代码。
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2021-9-23 02:38 , Processed in 0.877391 second(s), 48 queries , Gzip On.

Powered by Discuz! X3.4

Copyright © 2001-2020, Tencent Cloud.

快速回复 返回顶部 返回列表